<?php
/**
 * Returns an authorized API client.
 * @return Google_Client the authorized client object
 */
function getClient() {
  $client = new Google_Client();
  $client->setApplicationName(APPLICATION_NAME);
  $client->setScopes(SCOPES);
  $client->setAuthConfigFile(CLIENT_SECRET_PATH);
  $client->setAccessType('offline');

  // Load previously authorized credentials from a file.
  if (file_exists(CREDENTIALS_PATH)) {
    $accessToken = file_get_contents(CREDENTIALS_PATH);
  } else {
    // Request authorization from the user.
    $authUrl = $client->createAuthUrl();
    printf("Open the following link in your browser:<br>%s<br>", '<a target="_blank" href="'.$authUrl.'">'.$authUrl.'</a>');
    echo '<br>Enter verification code: <form method="post"><input type="text" name="code_token" /><input type="submit" value="OK" /></form>';
	if ($_POST['code_token']) {
		
		$authCode = trim($_POST['code_token']);
		//$authCode = trim(fgets(STDIN));

		// Exchange authorization code for an access token.
		$accessToken = $client->authenticate($authCode);

		// Store the credentials to disk.
		if(!file_exists(dirname(CREDENTIALS_PATH))) {
		  mkdir(dirname(CREDENTIALS_PATH), 0700, true);
		}
		file_put_contents(CREDENTIALS_PATH, $accessToken);
		printf("Credentials saved to <b>%s</b>", CREDENTIALS_PATH);
		die;
	}
  }
  if ($accessToken) {
	  $client->setAccessToken($accessToken);

	  // Refresh the token if it's expired.
	  if ($client->isAccessTokenExpired()) {
		$client->refreshToken($client->getRefreshToken());
		file_put_contents(CREDENTIALS_PATH, $client->getAccessToken());
	  }
	return $client;
  }
}

function deleteFile($service, $fileId) {
  try {
    $service->files->delete($fileId);
  } catch (Exception $e) {
    print "An error occurred: " . $e->getMessage();
  }
}